#pragma once

#include "TsPacketParser.h"
#include "TsDescrambler.h"
#include "FileWriter.h"
#include "TsServiceSelect.h"
#include "NetworkSend.h"
#include "EcmDat.h"
#include "KeepRate.h"
#include "ProgManager.h"
#include "TsDemuxer.h"
#include "HttpSend.h"

#define OPT_SEL			0x00000001
#define OPT_B25			0x00000002
#define OPT_UDP			0x00000004
#define OPT_DEMUX		0x00000008
#define OPT_FILEW		0x00000010
#define OPT_BDIAG		0x00000020
#define OPT_FFMPEG		0x00000040

class CEventHandler : public CDecoderHandler
{
public:

	CEventHandler(void);
	~CEventHandler(void);

	// IMediaDecoder hfBAfR[_NX

	BOOL Init(DWORD opt,LPCTSTR tsfname,DWORD PacketSize,DWORD buf_margin,DWORD buf_size,DWORD service);
	void Exit(void);

	void OnBcasData(BYTE* data,DWORD len);
	void OnTsData(BYTE* data,DWORD len);
	void CEventHandler::Reset(void);

protected:
	virtual const DWORD OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam);

private:
	CTsPacketParser* m_pTsPacketParser;
	CTsDescrambler* m_pTsDescrambler;
	CTsServiceSelect* m_pTsServiceSelect;
	CFileWriter* m_pFileWriter;
	CNetworkSend* m_pNetworkSend;
	CKeepRate* m_pKeepRate;
	CProgManager* m_pProgManager;
	CTsDemuxer* m_pTsDemuxer;
	CFileWriter* m_pVideoFile;
	CFileWriter* m_pAudioFile;
	CKeepRate* m_pFFmpgVideoBand;
	CHttpSend* m_pFFmpgVideo;
	CKeepRate* m_pFFmpgAudioBand;
	CHttpSend* m_pFFmpgAudio;

	char* m_tsfname;

};
