// FileWriter.cpp: CFileWriter NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FileWriter.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CFileWriter::CFileWriter(CDecoderHandler *pDecoderHandler)
	: CMediaDecoder(pDecoderHandler)
	, m_llWriteSize(0U)
	, m_llWriteCount(0U)
{
	m_CachePtr = 0;
	m_abyCache = new BYTE[FILE_CACHE_SIZE];
}

CFileWriter::~CFileWriter()
{
	CloseFile();
	delete [] m_abyCache;
}

void CFileWriter::Reset(void)
{

}

const DWORD CFileWriter::GetInputNum(void) const
{
	return 1UL;
}

const DWORD CFileWriter::GetOutputNum(void) const
{
	return 0UL;
}

const bool CFileWriter::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex >= GetInputNum())return false;
	if(m_CachePtr + pMediaData->GetSize() <= FILE_CACHE_SIZE){
		memcpy(&m_abyCache[m_CachePtr],pMediaData->GetData(), pMediaData->GetSize());
		m_CachePtr += pMediaData->GetSize();
	} else if (pMediaData->GetSize() <= FILE_CACHE_SIZE){
		if(m_OutFile.Write(m_abyCache, m_CachePtr)){
			m_llWriteSize += m_CachePtr;
			m_llWriteCount++;
			m_CachePtr = 0;
			memcpy(&m_abyCache[m_CachePtr],pMediaData->GetData(), pMediaData->GetSize());
			m_CachePtr += pMediaData->GetSize();
			return true;
		}
		return false;
	} else {
	// t@Cɏ
		if(m_OutFile.Write(pMediaData->GetData(), pMediaData->GetSize())){
			m_llWriteSize += pMediaData->GetSize();
			if(m_OutFile.Write(m_abyCache, m_CachePtr)){
				m_llWriteSize += m_CachePtr;
				m_llWriteCount++;
				return true;
			}
			return false;
		}
	}
	return true;
}

const bool CFileWriter::OpenFile(LPCTSTR lpszFileName)
{
	// U
	CloseFile();

	// t@CJ
	return (m_OutFile.Open(lpszFileName, CNCachedFile::CNF_WRITE | CNCachedFile::CNF_NEW | CNCachedFile::CNF_SHAREREAD))? true : false;
}

void CFileWriter::CloseFile(void)
{
	// t@C
	m_OutFile.Close();
	
	m_llWriteSize = 0U;
	m_llWriteCount = 0U;
}

const LONGLONG CFileWriter::GetWriteSize(void) const
{
	// ݍς݃TCYԂ
	return m_llWriteSize;
}

const LONGLONG CFileWriter::GetWriteCount(void) const
{
	// ݉񐔂Ԃ
	return m_llWriteCount;
}
