// ProgManager.cpp: CHttpSend NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HttpSend.h"

#include <process.h>

//////////////////////////////////////////////////////////////////////
//Staticvf

DWORD 				CHttpSend::m_ReqSocket = 0;
vector<SOCKET*>		CHttpSend::m_SocketAry;
HANDLE 				CHttpSend::m_thread = INVALID_HANDLE_VALUE;
SOCKET 				CHttpSend::m_server_sock = INVALID_SOCKET;
USHORT 				CHttpSend::m_port = 0;

int count = 0;
//HttpT[o[XbhBvꂽ\Pbg̐ڑmIB
void CHttpSend::ServerThread(LPVOID parm)
{
	struct sockaddr_in addr;
	struct sockaddr_in client;
	int len;
	DWORD sock_num = 0;
	SOCKET sock;
	BOOL yes = 1;
	char buf[128];
	char inbuf[128];

	m_server_sock = socket(AF_INET, SOCK_STREAM, 0);
	if (m_server_sock == INVALID_SOCKET) {
		log_out("HttpSend socket WSAGetLastError : %d\n", WSAGetLastError());
		return ;
	}
	
	addr.sin_family = AF_INET;
	addr.sin_port = htons(m_port);
	addr.sin_addr.S_un.S_addr = INADDR_ANY;
	
	setsockopt(m_server_sock,
		SOL_SOCKET, SO_REUSEADDR, (const char *)&yes, sizeof(yes));
	
	if (bind(m_server_sock, (struct sockaddr *)&addr, sizeof(addr)) != 0) {
		log_out("HttpSend bind WSAGetLastError : %d\n", WSAGetLastError());
		return ;
	}
	
	if (listen(m_server_sock, 5) != 0) {
		log_out("HttpSend listen WSAGetLastError : %d\n", WSAGetLastError());
		return ;
	}
	
	memset(buf, 0, sizeof(buf));
	GetModuleHandle(NULL);
//	sprintf(buf,"HTTP/1.0 200 OK\r\nContent-Length: 1397256\r\nContent-Type: audio/media\r\n\r\n");
	sprintf(buf,"HTTP/1.0 200 OK\r\n\r\n");
	
	while (1) {
		len = sizeof(client);
		sock = accept(m_server_sock, (struct sockaddr *)&client, &len);
		if (sock == INVALID_SOCKET) {
//			log_out("HttpSend accept WSAGetLastError : %d\n", WSAGetLastError());
			break;
		}
		
		memset(inbuf, 0, sizeof(inbuf));
		recv(sock, inbuf, sizeof(inbuf), 0);
		_mbslwr((unsigned char *)inbuf);
//		printf("%s", inbuf);
		
		send(sock, buf, (int)strlen(buf), 0);
		*m_SocketAry[sock_num++] = sock;
		if(sock_num >= m_ReqSocket){
			break;
		}
	}

	closesocket(m_server_sock);
	m_server_sock = INVALID_SOCKET;
	
	return ;

}


//////////////////////////////////////////////////////////////////////
// CHttpSend \z/
//////////////////////////////////////////////////////////////////////

CHttpSend::CHttpSend(CDecoderHandler *pDecoderHandler,USHORT Port)
	: CMediaDecoder(pDecoderHandler)
{
	// vOf[^x[XCX^X
	m_ReqSocket++;
	m_port = Port;

	m_sock = INVALID_SOCKET;
	m_SocketAry.push_back(&m_sock);

	m_CachePtr = 0;
	m_abyCache = new BYTE[HTTPSEND_CACHE_SIZE];

	WSADATA wsaData;
	WSAStartup(MAKEWORD(2,0), &wsaData);

	if(m_thread == INVALID_HANDLE_VALUE){
		m_thread = (HANDLE)_beginthread(&CHttpSend::ServerThread,NULL,0);
	}

}

CHttpSend::~CHttpSend()
{
	// vOf[^x[XCX^XJ
	m_ReqSocket--;

	if(m_ReqSocket == 0 && m_thread != INVALID_HANDLE_VALUE){
		if(m_server_sock != INVALID_SOCKET){
			closesocket(m_server_sock);
		}
		WaitForSingleObject(m_thread,1000);
		m_thread = INVALID_HANDLE_VALUE;

	}
	if(m_sock != INVALID_SOCKET){
		closesocket(m_sock);
	}

	delete [] m_abyCache;

	WSACleanup();	
}

void CHttpSend::Reset()
{
	// ʃfR[_Zbg
	CMediaDecoder::Reset();
}


const DWORD CHttpSend::GetInputNum() const
{
	return 1UL;
}

const DWORD CHttpSend::GetOutputNum() const
{
	return 0UL;		// [
}


BOOL CHttpSend::IsOpen(void)
{
	int i;
	
	if(m_sock == INVALID_SOCKET){			// rÂłB
		for(i = 0 ; i < 10000 ; i ++){
			Sleep(100);
			if(m_sock != INVALID_SOCKET) break;
		}
		if(i == 10) return FALSE;
	}
	return TRUE;
}

BOOL CHttpSend::Send(BYTE* buff,DWORD len)
{
	size_t ret;
	if(IsOpen() == FALSE){
		log_out("CHttpSend : Socket Connection Error\n");
		return FALSE;
	}
	ret = send(m_sock,(const char*)buff,len,0);
	if(ret == -1){
		log_out("HttpSend Send WSAGetLastError : %d\n", WSAGetLastError());
		return FALSE;
	}
	return TRUE;
}

#define HTTPSEND_SIZE_MAX	1024*1024*1024
const bool CHttpSend::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	BOOL ret;

	if(m_CachePtr + pMediaData->GetSize() <= HTTPSEND_CACHE_SIZE){

		memcpy(&m_abyCache[m_CachePtr],pMediaData->GetData(), pMediaData->GetSize());
		m_CachePtr += pMediaData->GetSize();

	} else if (pMediaData->GetSize() <= HTTPSEND_CACHE_SIZE){
		count++;
		ret = Send(m_abyCache, m_CachePtr);
		m_CachePtr = 0;
		memcpy(&m_abyCache[m_CachePtr],pMediaData->GetData(), pMediaData->GetSize());
		m_CachePtr += pMediaData->GetSize();
		return true;

	} else {

		DWORD len = pMediaData->GetSize();
		BYTE* buf = pMediaData->GetData();
		while(len){
			if(len >= HTTPSEND_SIZE_MAX){
				len -= HTTPSEND_SIZE_MAX;
				Send(buf,HTTPSEND_SIZE_MAX);
				buf += HTTPSEND_SIZE_MAX;
			} else {
				Send(buf,len);
				len = 0;
			}
		}
//		ret = Send(pMediaData->GetData(), pMediaData->GetSize());		// ɗĂ͂Ȃ
	}


	// ̃tB^Ƀf[^n
	OutputMedia(pMediaData);
	return true;
}

